library angular2.src.core.compiler.pipeline.shim_shadow_dom_dart;

import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;
import 'package:angular2/src/facade/lang.dart' show isPresent, Type;
import 'package:angular2/src/core/compiler/directive_metadata.dart'
    show DirectiveMetadata;
import 'package:angular2/src/core/compiler/shadow_dom_strategy.dart'
    show ShadowDomStrategy;

class ShimShadowDom extends CompileStep {
  ShadowDomStrategy _strategy;
  Type _component;
  ShimShadowDom(DirectiveMetadata cmpMetadata, ShadowDomStrategy strategy)
      : super() {
    this._strategy = strategy;
    this._component = cmpMetadata.type;
  }
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (current.ignoreBindings) {
      return;
    }
    this._strategy.shimContentElement(this._component, current.element);
    var host = current.componentDirective;
    if (isPresent(host)) {
      this._strategy.shimHostElement(host.type, current.element);
    }
  }
}
