library angular2.src.forms.validators_dart;

import 'package:angular2/src/facade/lang.dart' show isBlank, isPresent;
import 'package:angular2/src/facade/collection.dart'
    show List, ListWrapper, StringMapWrapper;
import 'package:angular2/forms.dart' show ControlGroup, Control;

required(Control c) {
  return isBlank(c.value) || c.value == "" ? {"required": true} : null;
}
nullValidator(Control c) {
  return null;
}
Function compose(List<Function> validators) {
  return (Control c) {
    var res = ListWrapper.reduce(validators, (res, validator) {
      var errors = validator(c);
      return isPresent(errors) ? StringMapWrapper.merge(res, errors) : res;
    }, {});
    return StringMapWrapper.isEmpty(res) ? null : res;
  };
}
controlGroupValidator(ControlGroup c) {
  var res = {};
  StringMapWrapper.forEach(c.controls, (control, name) {
    if (control.active && isPresent(control.errors)) {
      StringMapWrapper.forEach(control.errors, (value, error) {
        if (!StringMapWrapper.contains(res, error)) {
          res[error] = [];
        }
        ListWrapper.push(res[error], control);
      });
    }
  });
  return StringMapWrapper.isEmpty(res) ? null : res;
}
